Subject: [bess] A question about RFC 8317

From: Alexander Vainshtein <[email-masked]>
Date: Thu, 20 Dec 2018 11:29:50 +0000

Ali and all,
I have read RFC 8317<https://tools.ietf.org/html/rfc8317>, and I would like to clarify a question dealing with Leaf ACs of an EVPN-based E-Tree service on All-Active Multi-Homed Ethernet Segments (MH ES).

The reference model for my question is shown in the Embedded diagram below.

It shows an EVPN E-tree service with one Root customer site and two leaf customer sites, where each Leaf CE is dual-homed to the same pair of PEs using two different All-Active multi-homed Ethernet Segments.

Suppose that the scheme with two RTs (one identifying the Root site and the other identifying the Leaf sites) is used as described in 4.3.1.

Suppose also that each MAC-VRF uses per MAC-VRF label assignment as defined in section 9.2.1 of RFC 7432, i.e., advertises exactly one EVPN application label that identifies it as the Egress MAC-VRF, while the disposition of the received Ethernet frame within this MAC-VRF is based on the destination MAC address. In this case the per MAC-VRF label can be also used as the "aliasing" label in the per EVI EAD route.

PE-1 will receive and accept per EVI EAD routes for both MH ES for PE-2 and PE-3 with the corresponding "aliasing" labels.

Suppose that MAC-VRF in PE-2 learns some {MAC, IP} pair  {X, Y}  locally from the Leaf CE-1 and advertises this pair in the EVPN MAC/IP Advertisement route. With the "two RTs" scheme this route will be accepted by the MAC-VRF in PE-1 but it will not be accepted by the MAC-VRF in PE3. As a consequence:

-          MAC-VRF in PE-1 will know that this pair has been learned from the "blue" all-active MH ES, and therefore can decide to send locally received unicast frames with destination MAC address X to PE-3 using the corresponding "aliasing label". No other labels will be included in the EVN encapsulation of such  frames because they are received from the Root AC.

-          MAC-VRF in PE-3 will not know anything about MAC address X, therefore, when it receives an EVPN-encapsulated frame with this destination, it will treat it as an "unknown unicast" and flood it to both Leaf CE-1 (where it should be sent) and to Leaf CE-2 (where it should not be sent).

Is this what is really supposed to happen in this scenario? If not, what did I miss in the E-tree EVPN solution?

Regards, and lots of thanks in advance,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]

___________________________________________________________________________

This e-mail message is intended for the recipient only and contains information which is 
CONFIDENTIAL and which may be proprietary to ECI Telecom. If you have received this 
transmission in error, please inform us by e-mail, phone or fax, and then delete the original 
and all copies thereof.
___________________________________________________________________________

---

From: "Rabadan, Jorge (Nokia - US/Mountain View)" <[email-masked]>
Date: Thu, 20 Dec 2018 17:31:20 +0000

Hi Sasha,

What you are explaining is correct.

PE3 would flood anything for which MAC DA is unknown to both local ESes. That is normal behavior, only that in this case CE-1’s MAC will not be learned on PE3 until CE-1 hashes the traffic to PE3 and not only PE2 (which will happen if you have a decent number of flows). *Technically speaking*, the E-Tree solution works since you don’t have leaf-to-leaf communication. However, I would not use the two RT solution in this scenario since it could create unnecessary flooding to local ESes as you describe.

For this scenario I would always use a single RT per EVI, ingress filtering for unicast (based on the leaf indication on MAC/IP routes), and egress filtering for BUM based on leaf label, as explained in RFC8317.

My two cents.

Thank you.
Jorge

From: Alexander Vainshtein <[email-masked]>
Date: Thursday, December 20, 2018 at 12:30 PM
To: "Ali Sajassi <[email-masked]> ([email-masked])" <[email-masked]>
Cc: "Samer Salam (ssalam)" <[email-masked]>, "John E Drake ([email-masked])" <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>, "Rabadan, Jorge (Nokia - US/Mountain View)" <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: A question about RFC 8317

Ali and all,

Suppose also that each MAC-VRF uses per MAC-VRF label assignment as defined in section 9.2.1 of RFC 7432, i.e., advertises exactly one EVPN application label that identifies it as the Egress MAC-VRF, while the disposition of the received Ethernet frame within this MAC-VRF is based on the destination MAC address. In this case the per MAC-VRF label can be also used as the “aliasing” label in the per EVI EAD route.

PE-1 will receive and accept per EVI EAD routes for both MH ES for PE-2 and PE-3 with the corresponding “aliasing” labels.

Suppose that MAC-VRF in PE-2 learns some {MAC, IP} pair  {X, Y}  locally from the Leaf CE-1 and advertises this pair in the EVPN MAC/IP Advertisement route. With the “two RTs” scheme this route will be accepted by the MAC-VRF in PE-1 but it will not be accepted by the MAC-VRF in PE3. As a consequence:

-          MAC-VRF in PE-1 will know that this pair has been learned from the “blue” all-active MH ES, and therefore can decide to send locally received unicast frames with destination MAC address X to PE-3 using the corresponding “aliasing label”. No other labels will be included in the EVN encapsulation of such  frames because they are received from the Root AC.

-          MAC-VRF in PE-3 will not know anything about MAC address X, therefore, when it receives an EVPN-encapsulated frame with this destination, it will treat it as an “unknown unicast” and flood it to both Leaf CE-1 (where it should be sent) and to Leaf CE-2 (where it should not be sent).

Office: +972-39266302
Cell:      +972-549266302

---

From: "Ali Sajassi (sajassi)" <[email-masked]>
Date: Thu, 20 Dec 2018 17:52:05 +0000

Hi Sasha,

The use case that you have described below is a legitimate use case and if we look at what happens in RFC 7432 baseline, there is no flooding there because MAC addresses among multi-homing PEs get synch’d up and thus even a PE in the all-active multi-homing group doesn’t receive a flow from a locally connected CE, the frames destined toward that CE will not get flooded. So, we should expect the same behavior for the E-TREE. We do get the same behavior from E-TREE (RFC 8317) by using the solution described section 4 which is a comprehensive solution that works for both scenarios 1 & 2. It uses ingress filtering for unicast traffic and egress filtering for BUM traffic while still using a single Route Target just like RFC 7432.

The use of two RTs in scenario-1, was intended to describe a very limited use case where no communications is needed among leaf PEs (e.g., Single Homing or Single-Active). However, in case of All-Active MH, we do need communications among leaf PEs and thus we should use the solution described in section 4.

Cheers,
Ali

From: Alexander Vainshtein <[email-masked]>
Date: Thursday, December 20, 2018 at 3:30 AM
To: Cisco Employee <[email-masked]>
Cc: "Samer Salam (ssalam)" <[email-masked]>, "John E Drake ([email-masked])" <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: A question about RFC 8317

Ali and all,

  *   MAC-VRF in PE-1 will know that this pair has been learned from the “blue” all-active MH ES, and therefore can decide to send locally received unicast frames with destination MAC address X to PE-3 using the corresponding “aliasing label”. No other labels will be included in the EVN encapsulation of such  frames because they are received from the Root AC.
  *   MAC-VRF in PE-3 will not know anything about MAC address X, therefore, when it receives an EVPN-encapsulated frame with this destination, it will treat it as an “unknown unicast” and flood it to both Leaf CE-1 (where it should be sent) and to Leaf CE-2 (where it should not be sent).

Office: +972-39266302
Cell:      +972-549266302

---

From: Alexander Vainshtein <[email-masked]>
Date: Fri, 21 Dec 2018 07:33:51 +0000

Ali,
Lots of thanks for a prompt response.
I fully agree that tbe use case I've described can be addressed by the genegal techniques of RFC 8317.

I only wanted to u dersrand applicability of fbe "two RTs" scheme, and both Jorge and you confifm that it would result in undesirable behavior in this use case.

Regards,
Thumb typed by Sasha Vainshtein

________________________________
From: Ali Sajassi (sajassi) <[email-masked]>
Sent: Thursday, December 20, 2018 7:52:05 PM
To: Alexander Vainshtein
Cc: Samer Salam (ssalam); John E Drake ([email-masked]); [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: Re: A question about RFC 8317

Hi Sasha,

Cheers,
Ali

Ali and all,

Office: +972-39266302
Cell:      +972-549266302

---

From: Alexander Vainshtein <[email-masked]>
Date: Fri, 21 Dec 2018 07:42:14 +0000

Jorge,
Lots of thanks for a prompt response.
My conclusion js tbat the "two RTs" scheme should be used with special care in E-tree solutions. This was not my impression from the first reading of 8317.

Since the "two RTs" scheme is very popular in hub-and-spoke" solutiobs for IP VPN, the fact that it is not the universal answer in EVPN E-Tree deserves some expla ation IMHO- but I do not see how this can be done in IETF.

________________________________
From: Rabadan, Jorge (Nokia - US/Mountain View) <[email-masked]>
Sent: Thursday, December 20, 2018 7:31:20 PM
To: Alexander Vainshtein; Ali Sajassi <[email-masked]> ([email-masked])
Cc: Samer Salam (ssalam); John E Drake ([email-masked]); [email-masked]; [email-masked]; [email-masked]
Subject: Re: A question about RFC 8317

Hi Sasha,

My two cents.

Thank you.
Jorge

Ali and all,

Office: +972-39266302
Cell:      +972-549266302